## pineapple-pictures 0.4.1

=== CMakeLists.txt ===
project (pineapple-pictures)

cmake_minimum_required (VERSION 3.9.5)

list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_LIST_DIR}/cmake)

include (GNUInstallDirs)
include (FeatureSummary)

set (CMAKE_AUTOMOC ON)
set (CMAKE_AUTORCC ON)
set (QT_MINIMUM_VERSION "5.10")

option (EXIV2_METADATA_SUPPORT "Better image metadata support via libexiv2" ON)

find_package(Qt5 ${QT_MINIMUM_VERSION} CONFIG REQUIRED Widgets Svg LinguistTools)

if (EXIV2_METADATA_SUPPORT)
    find_package(LibExiv2)
    set_package_properties(LibExiv2 PROPERTIES
        URL "https://www.exiv2.org"
        DESCRIPTION "image metadata support"
        TYPE OPTIONAL
        PURPOSE "Bring better image metadata support"
    )
endif ()

#LibExiv2_FOUND
set (PPIC_CPP_FILES
    app/main.cpp
    app/framelesswindow.cpp
    app/mainwindow.cpp
    app/actionmanager.cpp
    app/graphicsview.cpp
    app/graphicsscene.cpp
    app/bottombuttongroup.cpp
    app/navigatorview.cpp
    app/opacityhelper.cpp
    app/toolbutton.cpp
    app/settings.cpp
    app/settingsdialog.cpp
    app/aboutdialog.cpp
    app/metadatamodel.cpp
    app/metadatadialog.cpp
    app/exiv2wrapper.cpp
)

set (PPIC_HEADER_FILES
    app/framelesswindow.h
    app/mainwindow.h
    app/actionmanager.h
    app/graphicsview.h
    app/graphicsscene.h
    app/bottombuttongroup.h
    app/navigatorview.h
    app/opacityhelper.h
    app/toolbutton.h
    app/settings.h
    app/settingsdialog.h
    app/aboutdialog.h
    app/metadatamodel.h
    app/metadatadialog.h
    app/exiv2wrapper.h
)

set (PPIC_QRC_FILES
    assets/resources.qrc
)

set (PPIC_RC_FILES
    # yeah, it's empty.
)

set (EXE_NAME ppic)

# Translation
file (GLOB PPIC_TS_FILES translations/*.ts)
set (PPIC_CPP_FILES_FOR_I18N ${PPIC_CPP_FILES})

qt5_create_translation(PPIC_QM_FILES ${PPIC_CPP_FILES_FOR_I18N} ${PPIC_TS_FILES})

if (WIN32)
    list(APPEND PPIC_RC_FILES assets/pineapple-pictures.rc)
endif ()

add_executable (${EXE_NAME}
    ${PPIC_HEADER_FILES}
    ${PPIC_CPP_FILES}
    ${PPIC_QRC_FILES}
    ${PPIC_RC_FILES}
    ${PPIC_QM_FILES}
)

target_link_libraries (${EXE_NAME} Qt5::Widgets Qt5::Svg)

if (LibExiv2_FOUND)
    message(INFO ${LibExiv2_INCLUDE_DIRS})
    target_include_directories(${EXE_NAME}
    PRIVATE
        ${LibExiv2_INCLUDE_DIRS}
    )
    target_link_libraries (${EXE_NAME}
        LibExiv2::LibExiv2
    )
    target_compile_definitions(${EXE_NAME} PRIVATE
        HAVE_EXIV2_VERSION="${LibExiv2_VERSION}"
    )
endif ()

# Extra build settings
if (WIN32)
    set_property (
        TARGET ${EXE_NAME}
        PROPERTY WIN32_EXECUTABLE true
    )

    target_compile_definitions(${EXE_NAME} PRIVATE
        FLAG_PORTABLE_MODE_SUPPORT=1
    )
endif ()

# Helper macros for parsing and setting project version from `git describe --long` result
macro (ppic_set_version_via_describe _describe_long)
    string (
        REGEX REPLACE
        "^([0-9a-z.]*)-[0-9]+-g[0-9a-f]*$"
        "\\1"
        _tag_parts
        "${_describe_long}"
    )
    list (GET _tag_parts 0 _matched_tag_version)
    if ("${_matched_tag_version}" MATCHES "^[0-9]+\\.[0-9]+\\.[0-9]+$")
        string (
            REGEX REPLACE
            "^([0-9]+)\\.([0-9]+)\\.([0-9]+).*$"
            "\\1;\\2;\\3"
            _ver_parts
            "${_matched_tag_version}"
        )
        list (GET _ver_parts 0 CPACK_PACKAGE_VERSION_MAJOR)
        list (GET _ver_parts 1 CPACK_PACKAGE_VERSION_MINOR)
        list (GET _ver_parts 2 CPACK_PACKAGE_VERSION_PATCH)
    endif ()
endmacro ()

# Version setup
if (EXISTS "${CMAKE_SOURCE_DIR}/.git")
    find_package(Git)
    set_package_properties(Git PROPERTIES TYPE OPTIONAL PURPOSE "Determine exact build version.")
    if (GIT_FOUND)
        execute_process (
            COMMAND ${GIT_EXECUTABLE} describe --tags --always --long
            WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
            OUTPUT_VARIABLE _git_describe_long
        )
        string (REGEX REPLACE "\n" "" _git_describe_long "${_git_describe_long}")
        ppic_set_version_via_describe(${_git_describe_long})
        target_compile_definitions(${EXE_NAME} PRIVATE
            GIT_DESCRIBE_VERSION_STRING="${_git_describe_long}"
        )
    endif ()
endif ()

# Helper macros for install settings
macro (ppic_convert_to_relative_path _var)
    # Make sure _var is a relative path
    if (IS_ABSOLUTE "${${_var}}")
        file (RELATIVE_PATH ${_var} "${CMAKE_INSTALL_PREFIX}" "${${_var}}")
    endif ()
endmacro ()

# Install settings
if (WIN32)
    # FIXME: try to avoid install to a "bin" subfolder under windows...
    #        when fixed, don't forget to update the CI config file...
    set (BIN_INSTALL_DIR "") # seems useless, don't know why...
elseif (UNIX)
    if (CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
        set(CMAKE_INSTALL_PREFIX /usr)
    endif ()

    set (BIN_INSTALL_DIR "${CMAKE_INSTALL_BINDIR}") # relative, usually "bin"
    ppic_convert_to_relative_path(BIN_INSTALL_DIR)
    set (LIB_INSTALL_DIR "${CMAKE_INSTALL_LIBDIR}") # "lib" or "lib64"
    ppic_convert_to_relative_path(LIB_INSTALL_DIR)

    # install icon
    install (
        FILES assets/icons/app-icon.svg
        DESTINATION "${CMAKE_INSTALL_DATADIR}/icons/hicolor/48x48/apps"
        RENAME pineapple-pictures.svg
    )

    # install shortcut
    install (
        FILES dist/net.blumia.pineapple-pictures.desktop
        DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/applications"
    )

    # install app metadata file for appstream (and some other stuff using this metadata like snapcraft)
    install (
        FILES dist/appstream/net.blumia.pineapple-pictures.appdata.xml
        DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/metainfo"
    )
endif()

set (INSTALL_TARGETS_DEFAULT_ARGS
    RUNTIME DESTINATION ${BIN_INSTALL_DIR}
    LIBRARY DESTINATION ${LIB_INSTALL_DIR}
    ARCHIVE DESTINATION ${LIB_INSTALL_DIR} COMPONENT Devel
)

install (
    TARGETS ${EXE_NAME}
    ${INSTALL_TARGETS_DEFAULT_ARGS}
)

if (WIN32)
    set (QM_FILE_INSTALL_DIR "${CMAKE_INSTALL_BINDIR}/translations")
else ()
    set (QM_FILE_INSTALL_DIR "${CMAKE_INSTALL_FULL_DATADIR}/pineapple-pictures/translations")
    target_compile_definitions(${EXE_NAME}
        PRIVATE QM_FILE_INSTALL_DIR=${QM_FILE_INSTALL_DIR}
    )
endif ()

install (
    FILES ${PPIC_QM_FILES}
    DESTINATION ${QM_FILE_INSTALL_DIR}
)

feature_summary(WHAT ALL INCLUDE_QUIET_PACKAGES FATAL_ON_MISSING_REQUIRED_PACKAGES)

# CPACK: General Settings
set (CPACK_GENERATOR "TBZ2")
set (CPACK_PACKAGE_NAME "pineapple-pictures")
set (CPACK_PACKAGE_DESCRIPTION_SUMMARY "Yet another image viewer")
set (CPACK_PACKAGE_VENDOR "Gary Wang")
set (CPACK_PACKAGE_CONTACT "https://github.com/BLumia/pineapple-pictures/issues/")
if (WIN32)
    # ...
elseif (APPLE)
    # ...
elseif (UNIX)
    set (CPACK_SYSTEM_NAME "${CMAKE_SYSTEM_NAME}-${CMAKE_SYSTEM_PROCESSOR}")
    set (CPACK_DEBIAN_PACKAGE_SHILIBDEPS ON)
    set (CPACK_DEBIAN_PACKAGE_RECOMMENDS "kimageformat-plugins")
endif()

include(CPack)

=== debian/changelog ===
pineapple-pictures (0.4.1-1build1) hirsute; urgency=medium

  * No change rebuild with fixed ownership.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 16 Feb 2021 17:04:06 +0000

pineapple-pictures (0.4.1-1) unstable; urgency=medium

  * New upstream version 0.4.1

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Sat, 06 Feb 2021 19:27:06 +0000

pineapple-pictures (0.4.0-2) unstable; urgency=medium

  * Enable metadata viewing with libexiv2.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Fri, 01 Jan 2021 16:46:14 +0000

pineapple-pictures (0.4.0-1) unstable; urgency=medium

  * New upstream version 0.4.0
    - Update copyright.
  * Update Standards-Version to 4.5.1

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Sat, 26 Dec 2020 20:02:28 +0000

pineapple-pictures (0.3.4-1) unstable; urgency=medium

  * New upstream version 0.3.4
    - Remove patches applied upstream.
  * Add autopkgtest.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Sat, 14 Nov 2020 23:33:17 +0000

pineapple-pictures (0.3.3-2) unstable; urgency=medium

  * Source only upload.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Wed, 28 Oct 2020 11:18:25 +0000

pineapple-pictures (0.3.3-1) unstable; urgency=medium

  * Initial release (Closes: #972376)

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Sat, 24 Oct 2020 19:16:30 +0100

=== debian/control ===
Source: pineapple-pictures
Section: graphics
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Sudip Mukherjee <sudipm.mukherjee@gmail.com>
Build-Depends: debhelper-compat (= 13), cmake, qtbase5-dev,
 libqt5svg5-dev, qttools5-dev, libexiv2-dev
Standards-Version: 4.5.1
Homepage: https://github.com/BLumia/pineapple-pictures
Vcs-Browser: https://salsa.debian.org/sudip/pineapple-pictures
Vcs-Git: https://salsa.debian.org/sudip/pineapple-pictures.git

Package: pineapple-pictures
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Lightweight Qt5 image viewer
 An uncluttered and fast image viewer which is very simple and easy to
 use. There is also an option to make the window stay on top so users
 can also pin the window with their image as a reference image window
 and work with other software they want. This software will always keep
 the image file as-is, will never accidentally modify the original
 image file when you just simply rotated the image and etc.
 .
 Key features:
   - Minimized UI
   - Fast
   - Easy to use
   - High quality scaling
   - Never modify the original image file
   - Stay-on-top option available for pinning reference image
     and work with other applications

## pineapple-pictures 0.5.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -43,6 +43,7 @@
     app/metadatamodel.cpp
     app/metadatadialog.cpp
     app/exiv2wrapper.cpp
+    app/playlistmanager.cpp
 )
 
 set (PPIC_HEADER_FILES
@@ -61,6 +62,7 @@
     app/metadatamodel.h
     app/metadatadialog.h
     app/exiv2wrapper.h
+    app/playlistmanager.h
 )
 
 set (PPIC_QRC_FILES
@@ -74,7 +76,7 @@
 set (EXE_NAME ppic)
 
 # Translation
-file (GLOB PPIC_TS_FILES translations/*.ts)
+file (GLOB PPIC_TS_FILES app/translations/*.ts)
 set (PPIC_CPP_FILES_FOR_I18N ${PPIC_CPP_FILES})
 
 qt5_create_translation(PPIC_QM_FILES ${PPIC_CPP_FILES_FOR_I18N} ${PPIC_TS_FILES})
@@ -199,7 +201,7 @@
 
     # install app metadata file for appstream (and some other stuff using this metadata like snapcraft)
     install (
-        FILES dist/appstream/net.blumia.pineapple-pictures.appdata.xml
+        FILES dist/appstream/net.blumia.pineapple-pictures.metainfo.xml
         DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/metainfo"
     )
 endif()

=== debian/changelog ===
pineapple-pictures (0.5.3-1) unstable; urgency=medium

  * New upstream version 0.5.3

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Thu, 23 Dec 2021 18:20:48 +0000

pineapple-pictures (0.5.2-1) unstable; urgency=medium

  [ Debian Janitor ]
  * Set upstream metadata fields: Bug-Database, Bug-Submit,
    Repository, Repository-Browse.

  [ Sudip Mukherjee ]
  * New upstream version 0.5.2
  * Update Standards-Version to 4.6.0.1

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Sun, 14 Nov 2021 22:15:59 +0000

pineapple-pictures (0.5.1-1) unstable; urgency=medium

  * Upload to unstable.
  * New upstream version 0.5.1

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Sat, 21 Aug 2021 20:03:42 +0100

pineapple-pictures (0.5.0-1) experimental; urgency=medium

  * New upstream version 0.5.0

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Sun, 01 Aug 2021 00:04:34 +0100

pineapple-pictures (0.4.4-1) experimental; urgency=medium

  * New upstream version 0.4.4
    - Update copyright.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Sat, 26 Jun 2021 23:07:40 +0100

pineapple-pictures (0.4.2-1) experimental; urgency=medium

  * New upstream version 0.4.2

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Fri, 02 Apr 2021 21:57:34 +0100

=== debian/control ===
--- 
+++ 
@@ -1,11 +1,10 @@
 Source: pineapple-pictures
 Section: graphics
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Sudip Mukherjee <sudipm.mukherjee@gmail.com>
+Maintainer: Sudip Mukherjee <sudipm.mukherjee@gmail.com>
 Build-Depends: debhelper-compat (= 13), cmake, qtbase5-dev,
  libqt5svg5-dev, qttools5-dev, libexiv2-dev
-Standards-Version: 4.5.1
+Standards-Version: 4.6.0.1
 Homepage: https://github.com/BLumia/pineapple-pictures
 Vcs-Browser: https://salsa.debian.org/sudip/pineapple-pictures
 Vcs-Git: https://salsa.debian.org/sudip/pineapple-pictures.git

## pineapple-pictures 0.6.1

=== debian/changelog ===
pineapple-pictures (0.6.1-1) unstable; urgency=medium

  * New upstream version 0.6.1

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Fri, 03 Jun 2022 11:35:03 +0100

pineapple-pictures (0.5.4-1) unstable; urgency=medium

  * New upstream version 0.5.4

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Sun, 20 Mar 2022 00:25:49 +0000

## pineapple-pictures 0.6.5

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,3 +1,7 @@
+# SPDX-FileCopyrightText: 2022 Gary Wang <wzc782970009@gmail.com>
+#
+# SPDX-License-Identifier: MIT
+
 project (pineapple-pictures)
 
 cmake_minimum_required (VERSION 3.9.5)
@@ -13,7 +17,10 @@
 
 option (EXIV2_METADATA_SUPPORT "Better image metadata support via libexiv2" ON)
 
-find_package(Qt5 ${QT_MINIMUM_VERSION} CONFIG REQUIRED Widgets Svg LinguistTools)
+find_package(Qt5 ${QT_MINIMUM_VERSION} REQUIRED
+    COMPONENTS Widgets Svg LinguistTools
+    OPTIONAL_COMPONENTS DBus
+)
 
 if (EXIV2_METADATA_SUPPORT)
     find_package(LibExiv2)
@@ -109,6 +116,15 @@
     )
 endif ()
 
+if (Qt5DBus_FOUND)
+    target_link_libraries (${EXE_NAME}
+        Qt5::DBus
+    )
+    target_compile_definitions(${EXE_NAME} PRIVATE
+        HAVE_QTDBUS
+    )
+endif()
+
 # Extra build settings
 if (WIN32)
     set_property (

=== debian/changelog ===
pineapple-pictures (0.6.5-1) unstable; urgency=medium

  * New upstream version 0.6.5
    - Update copyright.
  * Update Standards-Version to 4.6.1.0

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Mon, 02 Jan 2023 14:09:40 +0000

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Maintainer: Sudip Mukherjee <sudipm.mukherjee@gmail.com>
 Build-Depends: debhelper-compat (= 13), cmake, qtbase5-dev,
  libqt5svg5-dev, qttools5-dev, libexiv2-dev
-Standards-Version: 4.6.0.1
+Standards-Version: 4.6.1.0
 Homepage: https://github.com/BLumia/pineapple-pictures
 Vcs-Browser: https://salsa.debian.org/sudip/pineapple-pictures
 Vcs-Git: https://salsa.debian.org/sudip/pineapple-pictures.git

=== debian/watch ===
version=4

opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%pineapple-pictures-$1.tar.gz%" \
   https://github.com/BLumia/pineapple-pictures/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate

## pineapple-pictures 0.7.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-# SPDX-FileCopyrightText: 2022 Gary Wang <wzc782970009@gmail.com>
+# SPDX-FileCopyrightText: 2022 - 2023 Gary Wang <git@blumia.net>
 #
 # SPDX-License-Identifier: MIT
 
@@ -11,16 +11,32 @@
 include (GNUInstallDirs)
 include (FeatureSummary)
 
+option (EXIV2_METADATA_SUPPORT "Better image metadata support via libexiv2" ON)
+option (PREFER_QT_5 "Prefer to use Qt 5 even if we have Qt 6" ON)
+
 set (CMAKE_AUTOMOC ON)
 set (CMAKE_AUTORCC ON)
-set (QT_MINIMUM_VERSION "5.10")
-
-option (EXIV2_METADATA_SUPPORT "Better image metadata support via libexiv2" ON)
-
-find_package(Qt5 ${QT_MINIMUM_VERSION} REQUIRED
+
+if (PREFER_QT_5)
+    find_package(QT NAMES Qt5 REQUIRED COMPONENTS Core)
+else ()
+    find_package(QT NAMES Qt6 Qt5 REQUIRED COMPONENTS Core)
+endif ()
+
+if (${QT_VERSION_MAJOR} EQUAL "5")
+    set (QT_MINIMUM_VERSION "5.15.2")
+else ()
+    set (QT_MINIMUM_VERSION "6.4")
+endif ()
+
+find_package(Qt${QT_VERSION_MAJOR} ${QT_MINIMUM_VERSION} REQUIRED
     COMPONENTS Widgets Svg LinguistTools
     OPTIONAL_COMPONENTS DBus
 )
+
+if (${QT_VERSION_MAJOR} EQUAL "6")
+    find_package(Qt${QT_DEFAULT_MAJOR_VERSION} ${QT_MINIMUM_VERSION} CONFIG REQUIRED SvgWidgets)
+endif ()
 
 if (EXIV2_METADATA_SUPPORT)
     find_package(LibExiv2)
@@ -86,7 +102,7 @@
 file (GLOB PPIC_TS_FILES app/translations/*.ts)
 set (PPIC_CPP_FILES_FOR_I18N ${PPIC_CPP_FILES})
 
-qt5_create_translation(PPIC_QM_FILES ${PPIC_CPP_FILES_FOR_I18N} ${PPIC_TS_FILES})
+qt_create_translation(PPIC_QM_FILES ${PPIC_CPP_FILES_FOR_I18N} ${PPIC_TS_FILES})
 
 if (WIN32)
     list(APPEND PPIC_RC_FILES assets/pineapple-pictures.rc)
@@ -100,7 +116,10 @@
     ${PPIC_QM_FILES}
 )
 
-target_link_libraries (${EXE_NAME} Qt5::Widgets Qt5::Svg)
+target_link_libraries (${EXE_NAME} Qt${QT_VERSION_MAJOR}::Widgets Qt${QT_VERSION_MAJOR}::Svg)
+if (${QT_VERSION_MAJOR} EQUAL "6")
+    target_link_libraries (${EXE_NAME} Qt::SvgWidgets)
+endif ()
 
 if (LibExiv2_FOUND)
     message(INFO ${LibExiv2_INCLUDE_DIRS})
@@ -116,9 +135,9 @@
     )
 endif ()
 
-if (Qt5DBus_FOUND)
+if (Qt5DBus_FOUND OR Qt6DBus_FOUND)
     target_link_libraries (${EXE_NAME}
-        Qt5::DBus
+        Qt${QT_VERSION_MAJOR}::DBus
     )
     target_compile_definitions(${EXE_NAME} PRIVATE
         HAVE_QTDBUS
@@ -179,28 +198,14 @@
     endif ()
 endif ()
 
-# Helper macros for install settings
-macro (ppic_convert_to_relative_path _var)
-    # Make sure _var is a relative path
-    if (IS_ABSOLUTE "${${_var}}")
-        file (RELATIVE_PATH ${_var} "${CMAKE_INSTALL_PREFIX}" "${${_var}}")
-    endif ()
-endmacro ()
-
 # Install settings
 if (WIN32)
-    # FIXME: try to avoid install to a "bin" subfolder under windows...
-    #        when fixed, don't forget to update the CI config file...
-    set (BIN_INSTALL_DIR "") # seems useless, don't know why...
+    # TODO: try to avoid install to a "bin" subfolder under windows...
+    #       when fixed, don't forget to update the CI config file...
 elseif (UNIX)
     if (CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
         set(CMAKE_INSTALL_PREFIX /usr)
     endif ()
-
-    set (BIN_INSTALL_DIR "${CMAKE_INSTALL_BINDIR}") # relative, usually "bin"
-    ppic_convert_to_relative_path(BIN_INSTALL_DIR)
-    set (LIB_INSTALL_DIR "${CMAKE_INSTALL_LIBDIR}") # "lib" or "lib64"
-    ppic_convert_to_relative_path(LIB_INSTALL_DIR)
 
     # install icon
     install (
@@ -223,9 +228,9 @@
 endif()
 
 set (INSTALL_TARGETS_DEFAULT_ARGS
-    RUNTIME DESTINATION ${BIN_INSTALL_DIR}
-    LIBRARY DESTINATION ${LIB_INSTALL_DIR}
-    ARCHIVE DESTINATION ${LIB_INSTALL_DIR} COMPONENT Devel
+    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
+    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
+    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR} COMPONENT Devel
 )
 
 install (

=== debian/changelog ===
pineapple-pictures (0.7.0-1) unstable; urgency=medium

  * New upstream version 0.7.0
    - Update copyright.
  * Update Standards-Version to 4.6.2

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Fri, 16 Jun 2023 22:13:01 +0100

## pineapple-pictures 0.7.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -210,8 +210,8 @@
     # install icon
     install (
         FILES assets/icons/app-icon.svg
-        DESTINATION "${CMAKE_INSTALL_DATADIR}/icons/hicolor/48x48/apps"
-        RENAME pineapple-pictures.svg
+        DESTINATION "${CMAKE_INSTALL_DATADIR}/icons/hicolor/scalable/apps"
+        RENAME net.blumia.pineapple-pictures.svg
     )
 
     # install shortcut

=== debian/changelog ===
pineapple-pictures (0.7.3-1build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 18:10:30 +1100

pineapple-pictures (0.7.3-1build1) noble; urgency=medium

  * No-change rebuild against libqt5core5t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 15 Mar 2024 06:24:20 +0000

pineapple-pictures (0.7.3-1) unstable; urgency=medium

  * New upstream version 0.7.3

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Sun, 21 Jan 2024 22:26:26 +0000

=== debian/control ===
--- 
+++ 
@@ -1,10 +1,11 @@
 Source: pineapple-pictures
 Section: graphics
 Priority: optional
-Maintainer: Sudip Mukherjee <sudipm.mukherjee@gmail.com>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Sudip Mukherjee <sudipm.mukherjee@gmail.com>
 Build-Depends: debhelper-compat (= 13), cmake, qtbase5-dev,
  libqt5svg5-dev, qttools5-dev, libexiv2-dev
-Standards-Version: 4.6.1.0
+Standards-Version: 4.6.2
 Homepage: https://github.com/BLumia/pineapple-pictures
 Vcs-Browser: https://salsa.debian.org/sudip/pineapple-pictures
 Vcs-Git: https://salsa.debian.org/sudip/pineapple-pictures.git

## pineapple-pictures 0.7.4

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,10 +1,10 @@
-# SPDX-FileCopyrightText: 2022 - 2023 Gary Wang <git@blumia.net>
+# SPDX-FileCopyrightText: 2022 - 2024 Gary Wang <git@blumia.net>
 #
 # SPDX-License-Identifier: MIT
 
+cmake_minimum_required (VERSION 3.9.5)
+
 project (pineapple-pictures)
-
-cmake_minimum_required (VERSION 3.9.5)
 
 list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_LIST_DIR}/cmake)
 
@@ -12,15 +12,17 @@
 include (FeatureSummary)
 
 option (EXIV2_METADATA_SUPPORT "Better image metadata support via libexiv2" ON)
-option (PREFER_QT_5 "Prefer to use Qt 5 even if we have Qt 6" ON)
-
+option (PREFER_QT_5 "Prefer to use Qt 5" OFF)
+
+set (CMAKE_CXX_STANDARD 17)
+set (CMAKE_CXX_STANDARD_REQUIRED ON)
 set (CMAKE_AUTOMOC ON)
 set (CMAKE_AUTORCC ON)
 
 if (PREFER_QT_5)
     find_package(QT NAMES Qt5 REQUIRED COMPONENTS Core)
 else ()
-    find_package(QT NAMES Qt6 Qt5 REQUIRED COMPONENTS Core)
+    find_package(QT NAMES Qt6 REQUIRED COMPONENTS Core)
 endif ()
 
 if (${QT_VERSION_MAJOR} EQUAL "5")
@@ -102,19 +104,20 @@
 file (GLOB PPIC_TS_FILES app/translations/*.ts)
 set (PPIC_CPP_FILES_FOR_I18N ${PPIC_CPP_FILES})
 
-qt_create_translation(PPIC_QM_FILES ${PPIC_CPP_FILES_FOR_I18N} ${PPIC_TS_FILES})
-
 if (WIN32)
     list(APPEND PPIC_RC_FILES assets/pineapple-pictures.rc)
 endif ()
 
-add_executable (${EXE_NAME}
+add_executable (${EXE_NAME} WIN32
     ${PPIC_HEADER_FILES}
     ${PPIC_CPP_FILES}
     ${PPIC_QRC_FILES}
     ${PPIC_RC_FILES}
-    ${PPIC_QM_FILES}
-)
+)
+
+qt_create_translation(PPIC_QM_FILES ${PPIC_CPP_FILES_FOR_I18N} ${PPIC_TS_FILES})
+
+target_sources(${EXE_NAME} PRIVATE ${PPIC_QM_FILES})
 
 target_link_libraries (${EXE_NAME} Qt${QT_VERSION_MAJOR}::Widgets Qt${QT_VERSION_MAJOR}::Svg)
 if (${QT_VERSION_MAJOR} EQUAL "6")
@@ -135,7 +138,7 @@
     )
 endif ()
 
-if (Qt5DBus_FOUND OR Qt6DBus_FOUND)
+if (TARGET Qt5::DBus OR TARGET Qt6::DBus)
     target_link_libraries (${EXE_NAME}
         Qt${QT_VERSION_MAJOR}::DBus
     )
@@ -146,11 +149,6 @@
 
 # Extra build settings
 if (WIN32)
-    set_property (
-        TARGET ${EXE_NAME}
-        PROPERTY WIN32_EXECUTABLE true
-    )
-
     target_compile_definitions(${EXE_NAME} PRIVATE
         FLAG_PORTABLE_MODE_SUPPORT=1
     )

=== debian/changelog ===
pineapple-pictures (0.7.4-1) unstable; urgency=medium

  * New upstream version 0.7.4
    - Update copyright.
    - Update to qt6.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Sat, 25 May 2024 10:15:59 +0100

=== debian/control ===
--- 
+++ 
@@ -1,10 +1,9 @@
 Source: pineapple-pictures
 Section: graphics
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Sudip Mukherjee <sudipm.mukherjee@gmail.com>
-Build-Depends: debhelper-compat (= 13), cmake, qtbase5-dev,
- libqt5svg5-dev, qttools5-dev, libexiv2-dev
+Maintainer: Sudip Mukherjee <sudipm.mukherjee@gmail.com>
+Build-Depends: debhelper-compat (= 13), cmake, qt6-base-dev,
+ qt6-svg-dev, qt6-tools-dev, libexiv2-dev
 Standards-Version: 4.6.2
 Homepage: https://github.com/BLumia/pineapple-pictures
 Vcs-Browser: https://salsa.debian.org/sudip/pineapple-pictures

## pineapple-pictures 0.8.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -115,7 +115,11 @@
     ${PPIC_RC_FILES}
 )
 
-qt_create_translation(PPIC_QM_FILES ${PPIC_CPP_FILES_FOR_I18N} ${PPIC_TS_FILES})
+if (${QT_VERSION_MAJOR} EQUAL "6")
+    qt_add_translations(${EXE_NAME} TS_FILES ${PPIC_TS_FILES} QM_FILES_OUTPUT_VARIABLE PPIC_QM_FILES)
+else()
+    qt_create_translation(PPIC_QM_FILES ${PPIC_CPP_FILES_FOR_I18N} ${PPIC_TS_FILES})
+endif()
 
 target_sources(${EXE_NAME} PRIVATE ${PPIC_QM_FILES})
 
@@ -264,7 +268,7 @@
     # ...
 elseif (UNIX)
     set (CPACK_SYSTEM_NAME "${CMAKE_SYSTEM_NAME}-${CMAKE_SYSTEM_PROCESSOR}")
-    set (CPACK_DEBIAN_PACKAGE_SHILIBDEPS ON)
+    set (CPACK_DEBIAN_PACKAGE_SHLIBDEPS ON)
     set (CPACK_DEBIAN_PACKAGE_RECOMMENDS "kimageformat-plugins")
 endif()

=== debian/changelog ===
pineapple-pictures (0.8.0-1) unstable; urgency=medium

  * New upstream version 0.8.0

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Sat, 27 Jul 2024 10:46:29 +0100

## pineapple-pictures 0.8.2.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -4,9 +4,7 @@
 
 cmake_minimum_required (VERSION 3.9.5)
 
-project (pineapple-pictures)
-
-list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_LIST_DIR}/cmake)
+project(pineapple-pictures VERSION 0.8.2.1) # don't forget to update NEWS file and AppStream metadata.
 
 include (GNUInstallDirs)
 include (FeatureSummary)
@@ -41,8 +39,8 @@
 endif ()
 
 if (EXIV2_METADATA_SUPPORT)
-    find_package(LibExiv2)
-    set_package_properties(LibExiv2 PROPERTIES
+    find_package(Exiv2)
+    set_package_properties(Exiv2 PROPERTIES
         URL "https://www.exiv2.org"
         DESCRIPTION "image metadata support"
         TYPE OPTIONAL
@@ -50,7 +48,6 @@
     )
 endif ()
 
-#LibExiv2_FOUND
 set (PPIC_CPP_FILES
     app/main.cpp
     app/framelesswindow.cpp
@@ -128,17 +125,16 @@
     target_link_libraries (${EXE_NAME} Qt::SvgWidgets)
 endif ()
 
-if (LibExiv2_FOUND)
-    message(INFO ${LibExiv2_INCLUDE_DIRS})
-    target_include_directories(${EXE_NAME}
-    PRIVATE
-        ${LibExiv2_INCLUDE_DIRS}
-    )
+if (Exiv2_FOUND)
+    if(NOT TARGET Exiv2::exiv2lib AND TARGET exiv2lib)
+        # for exiv2 0.27.x
+        add_library(Exiv2::exiv2lib ALIAS exiv2lib)
+    endif()
     target_link_libraries (${EXE_NAME}
-        LibExiv2::LibExiv2
+        Exiv2::exiv2lib
     )
     target_compile_definitions(${EXE_NAME} PRIVATE
-        HAVE_EXIV2_VERSION="${LibExiv2_VERSION}"
+        HAVE_EXIV2_VERSION="${Exiv2_VERSION}"
     )
 endif ()
 
@@ -183,6 +179,7 @@
 endmacro ()
 
 # Version setup
+target_compile_definitions(${EXE_NAME} PRIVATE PPIC_VERSION_STRING="${CMAKE_PROJECT_VERSION}")
 if (EXISTS "${CMAKE_SOURCE_DIR}/.git")
     find_package(Git)
     set_package_properties(Git PROPERTIES TYPE OPTIONAL PURPOSE "Determine exact build version.")

=== debian/changelog ===
pineapple-pictures (0.8.2.1-1) unstable; urgency=medium

  * New upstream version 0.8.2.1
  * Update Standards-Version to 4.7.0

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Sun, 03 Nov 2024 22:08:54 +0000

pineapple-pictures (0.8.1-1) unstable; urgency=medium

  * New upstream version 0.8.1
  * Update copyright.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Tue, 15 Oct 2024 21:21:51 +0100

## pineapple-pictures 0.9.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -2,9 +2,9 @@
 #
 # SPDX-License-Identifier: MIT
 
-cmake_minimum_required (VERSION 3.9.5)
-
-project(pineapple-pictures VERSION 0.8.2.1) # don't forget to update NEWS file and AppStream metadata.
+cmake_minimum_required(VERSION 3.16)
+
+project(pineapple-pictures VERSION 0.9.0) # don't forget to update NEWS file and AppStream metadata.
 
 include (GNUInstallDirs)
 include (FeatureSummary)
@@ -66,6 +66,7 @@
     app/metadatadialog.cpp
     app/exiv2wrapper.cpp
     app/playlistmanager.cpp
+    app/shortcutedit.cpp
 )
 
 set (PPIC_HEADER_FILES
@@ -85,6 +86,7 @@
     app/metadatadialog.h
     app/exiv2wrapper.h
     app/playlistmanager.h
+    app/shortcutedit.h
 )
 
 set (PPIC_QRC_FILES
@@ -105,7 +107,7 @@
     list(APPEND PPIC_RC_FILES assets/pineapple-pictures.rc)
 endif ()
 
-add_executable (${EXE_NAME} WIN32
+add_executable (${EXE_NAME}
     ${PPIC_HEADER_FILES}
     ${PPIC_CPP_FILES}
     ${PPIC_QRC_FILES}
@@ -199,8 +201,24 @@
 
 # Install settings
 if (WIN32)
-    # TODO: try to avoid install to a "bin" subfolder under windows...
-    #       when fixed, don't forget to update the CI config file...
+    set_target_properties(${EXE_NAME} PROPERTIES
+        WIN32_EXECUTABLE TRUE
+    )
+elseif (APPLE)
+    set_source_files_properties(assets/icons/app-icon.icns PROPERTIES
+        MACOSX_PACKAGE_LOCATION "Resources"
+    )
+    target_sources(${EXE_NAME} PUBLIC assets/icons/app-icon.icns)
+    # See https://cmake.org/cmake/help/v3.15/prop_tgt/MACOSX_BUNDLE_INFO_PLIST.html
+    set_target_properties(${EXE_NAME} PROPERTIES
+        MACOSX_BUNDLE TRUE
+        MACOSX_BUNDLE_INFO_PLIST ${CMAKE_CURRENT_SOURCE_DIR}/dist/MacOSXBundleInfo.plist.in
+        MACOSX_BUNDLE_BUNDLE_NAME "Pineapple Pictures"
+        MACOSX_BUNDLE_GUI_IDENTIFIER net.blumia.pineapple-pictures
+        MACOSX_BUNDLE_ICON_FILE app-icon.icns # contains the .icns file name, *without* the path.
+        MACOSX_BUNDLE_BUNDLE_VERSION ${PROJECT_VERSION}
+        MACOSX_BUNDLE_SHORT_VERSION_STRING ${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}
+    )
 elseif (UNIX)
     if (CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
         set(CMAKE_INSTALL_PREFIX /usr)
@@ -227,6 +245,7 @@
 endif()
 
 set (INSTALL_TARGETS_DEFAULT_ARGS
+    BUNDLE DESTINATION .
     RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
     LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
     ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR} COMPONENT Devel

=== debian/changelog ===
pineapple-pictures (0.9.0-1) unstable; urgency=medium

  * New upstream version 0.9.0

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Fri, 27 Dec 2024 14:33:57 +0000

## pineapple-pictures 0.9.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -4,13 +4,14 @@
 
 cmake_minimum_required(VERSION 3.16)
 
-project(pineapple-pictures VERSION 0.9.0) # don't forget to update NEWS file and AppStream metadata.
+project(pineapple-pictures VERSION 0.9.1) # don't forget to update NEWS file and AppStream metadata.
 
 include (GNUInstallDirs)
 include (FeatureSummary)
 
 option (EXIV2_METADATA_SUPPORT "Better image metadata support via libexiv2" ON)
 option (PREFER_QT_5 "Prefer to use Qt 5" OFF)
+option (TRANSLATION_RESOURCE_EMBEDDING "Embedding .qm translation files inside resource" OFF)
 
 set (CMAKE_CXX_STANDARD 17)
 set (CMAKE_CXX_STANDARD_REQUIRED ON)
@@ -67,6 +68,7 @@
     app/exiv2wrapper.cpp
     app/playlistmanager.cpp
     app/shortcutedit.cpp
+    app/fileopeneventhandler.cpp
 )
 
 set (PPIC_HEADER_FILES
@@ -87,6 +89,7 @@
     app/exiv2wrapper.h
     app/playlistmanager.h
     app/shortcutedit.h
+    app/fileopeneventhandler.h
 )
 
 set (PPIC_QRC_FILES
@@ -115,7 +118,11 @@
 )
 
 if (${QT_VERSION_MAJOR} EQUAL "6")
-    qt_add_translations(${EXE_NAME} TS_FILES ${PPIC_TS_FILES} QM_FILES_OUTPUT_VARIABLE PPIC_QM_FILES)
+    if (TRANSLATION_RESOURCE_EMBEDDING)
+        qt_add_translations(${EXE_NAME} TS_FILES ${PPIC_TS_FILES})
+    else()
+        qt_add_translations(${EXE_NAME} TS_FILES ${PPIC_TS_FILES} QM_FILES_OUTPUT_VARIABLE PPIC_QM_FILES)
+    endif()
 else()
     qt_create_translation(PPIC_QM_FILES ${PPIC_CPP_FILES_FOR_I18N} ${PPIC_TS_FILES})
 endif()
@@ -256,19 +263,25 @@
     ${INSTALL_TARGETS_DEFAULT_ARGS}
 )
 
-if (WIN32)
+if (TRANSLATION_RESOURCE_EMBEDDING)
+    target_compile_definitions(${EXE_NAME}
+        PRIVATE TRANSLATION_RESOURCE_EMBEDDING
+    )
+elseif (WIN32)
     set (QM_FILE_INSTALL_DIR "${CMAKE_INSTALL_BINDIR}/translations")
-else ()
+else()
     set (QM_FILE_INSTALL_DIR "${CMAKE_INSTALL_FULL_DATADIR}/pineapple-pictures/translations")
     target_compile_definitions(${EXE_NAME}
-        PRIVATE QM_FILE_INSTALL_DIR=${QM_FILE_INSTALL_DIR}
-    )
-endif ()
-
-install (
-    FILES ${PPIC_QM_FILES}
-    DESTINATION ${QM_FILE_INSTALL_DIR}
-)
+        PRIVATE QM_FILE_INSTALL_ABSOLUTE_DIR=${QM_FILE_INSTALL_DIR}
+    )
+endif()
+
+if (DEFINED QM_FILE_INSTALL_DIR)
+    install(
+        FILES ${PPIC_QM_FILES}
+        DESTINATION ${QM_FILE_INSTALL_DIR}
+    )
+endif()
 
 feature_summary(WHAT ALL INCLUDE_QUIET_PACKAGES FATAL_ON_MISSING_REQUIRED_PACKAGES)

=== debian/changelog ===
pineapple-pictures (0.9.1-1) unstable; urgency=medium

  * New upstream version 0.9.1
    - Update copyright.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Wed, 19 Feb 2025 21:11:03 +0000

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Maintainer: Sudip Mukherjee <sudipm.mukherjee@gmail.com>
 Build-Depends: debhelper-compat (= 13), cmake, qt6-base-dev,
  qt6-svg-dev, qt6-tools-dev, libexiv2-dev
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Homepage: https://github.com/BLumia/pineapple-pictures
 Vcs-Browser: https://salsa.debian.org/sudip/pineapple-pictures
 Vcs-Git: https://salsa.debian.org/sudip/pineapple-pictures.git

## pineapple-pictures 0.9.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,13 +1,13 @@
-# SPDX-FileCopyrightText: 2022 - 2024 Gary Wang <git@blumia.net>
+# SPDX-FileCopyrightText: 2022 - 2025 Gary Wang <git@blumia.net>
 #
 # SPDX-License-Identifier: MIT
 
 cmake_minimum_required(VERSION 3.16)
 
-project(pineapple-pictures VERSION 0.9.1) # don't forget to update NEWS file and AppStream metadata.
-
-include (GNUInstallDirs)
-include (FeatureSummary)
+project(pineapple-pictures VERSION 0.9.2) # don't forget to update NEWS file and AppStream metadata.
+
+include(GNUInstallDirs)
+include(FeatureSummary)
 
 option (EXIV2_METADATA_SUPPORT "Better image metadata support via libexiv2" ON)
 option (PREFER_QT_5 "Prefer to use Qt 5" OFF)
@@ -40,11 +40,11 @@
 endif ()
 
 if (EXIV2_METADATA_SUPPORT)
-    find_package(Exiv2)
-    set_package_properties(Exiv2 PROPERTIES
+    find_package(exiv2)
+    set_package_properties(exiv2 PROPERTIES
         URL "https://www.exiv2.org"
         DESCRIPTION "image metadata support"
-        TYPE OPTIONAL
+        TYPE RECOMMENDED
         PURPOSE "Bring better image metadata support"
     )
 endif ()
@@ -134,7 +134,7 @@
     target_link_libraries (${EXE_NAME} Qt::SvgWidgets)
 endif ()
 
-if (Exiv2_FOUND)
+if (exiv2_FOUND)
     if(NOT TARGET Exiv2::exiv2lib AND TARGET exiv2lib)
         # for exiv2 0.27.x
         add_library(Exiv2::exiv2lib ALIAS exiv2lib)
@@ -143,7 +143,7 @@
         Exiv2::exiv2lib
     )
     target_compile_definitions(${EXE_NAME} PRIVATE
-        HAVE_EXIV2_VERSION="${Exiv2_VERSION}"
+        HAVE_EXIV2_VERSION="${exiv2_VERSION}"
     )
 endif ()

=== debian/changelog ===
pineapple-pictures (0.9.2-1) unstable; urgency=medium

  * New upstream version 0.9.2
    - Update copyright.
  * Update Standards-Version to 4.7.2

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Sun, 06 Apr 2025 16:31:24 +0100

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Maintainer: Sudip Mukherjee <sudipm.mukherjee@gmail.com>
 Build-Depends: debhelper-compat (= 13), cmake, qt6-base-dev,
  qt6-svg-dev, qt6-tools-dev, libexiv2-dev
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Homepage: https://github.com/BLumia/pineapple-pictures
 Vcs-Browser: https://salsa.debian.org/sudip/pineapple-pictures
 Vcs-Git: https://salsa.debian.org/sudip/pineapple-pictures.git

## pineapple-pictures 1.0.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -4,7 +4,7 @@
 
 cmake_minimum_required(VERSION 3.16)
 
-project(pineapple-pictures VERSION 0.9.2) # don't forget to update NEWS file and AppStream metadata.
+project(pineapple-pictures VERSION 1.0.0) # don't forget to update NEWS file and AppStream metadata.
 
 include(GNUInstallDirs)
 include(FeatureSummary)
@@ -118,10 +118,16 @@
 )
 
 if (${QT_VERSION_MAJOR} EQUAL "6")
+    set(ADD_TRANSLATIONS_ADDITIONAL_ARGS)
+
+    if (Qt6_VERSION VERSION_GREATER_EQUAL "6.9.0")
+        set(ADD_TRANSLATIONS_ADDITIONAL_ARGS MERGE_QT_TRANSLATIONS)
+    endif()
+
     if (TRANSLATION_RESOURCE_EMBEDDING)
-        qt_add_translations(${EXE_NAME} TS_FILES ${PPIC_TS_FILES})
+        qt_add_translations(${EXE_NAME} ${ADD_TRANSLATIONS_ADDITIONAL_ARGS} TS_FILES ${PPIC_TS_FILES})
     else()
-        qt_add_translations(${EXE_NAME} TS_FILES ${PPIC_TS_FILES} QM_FILES_OUTPUT_VARIABLE PPIC_QM_FILES)
+        qt_add_translations(${EXE_NAME} ${ADD_TRANSLATIONS_ADDITIONAL_ARGS} TS_FILES ${PPIC_TS_FILES} QM_FILES_OUTPUT_VARIABLE PPIC_QM_FILES)
     endif()
 else()
     qt_create_translation(PPIC_QM_FILES ${PPIC_CPP_FILES_FOR_I18N} ${PPIC_TS_FILES})

=== debian/changelog ===
pineapple-pictures (1.0.0-1deepin1) unstable; urgency=medium

  * New upstream release.

 -- lhdjply <lhdjply@126.com>  Tue, 29 Apr 2025 13:57:38 +0800

=== debian/control ===
Source: pineapple-pictures
Section: graphics
Priority: optional
Maintainer: Wang Zichong <wangzichong@deepin.org>
Build-Depends: debhelper-compat (= 13),
               cmake, 
               qt6-tools-dev,
               qt6-svg-dev,
               libexiv2-dev,
Rules-Requires-Root: no
Standards-Version: 4.7.2
Homepage: https://github.com/BLumia/pineapple-pictures/
Vcs-Browser: https://github.com/deepin-community/pineapple-pictures
Vcs-Git: https://github.com/deepin-community/pineapple-pictures.git

Package: pineapple-pictures
Section: graphics
Priority: optional
Architecture: any
Depends: 
 ${shlibs:Depends},
 ${misc:Depends}
Recommends: kimageformat6-plugins
Description: Pineapple Pictures is a lightweight image viewer
 Pineapple Pictures is a lightweight image viewer that allows you view JPEG, PNG, GIF, SVG, PSD, KRA, XCF, TGA, AVIF and some other frequently used image formats files quickly and easily, and also provide a Stay-on-Top window setting that allows you pin the window so you can use it to pin a reference image at the top and then you can work with other software.

=== debian/watch ===
version=4

opts="\
    compression=gz, \
    dversionmangle=s/\+(?:git)?[0-9]*(?:\+g[0-9a-f]*)//, \
    downloadurlmangle=s#/tag/#/download/#;s#(@ANY_VERSION@)$#$1/@PACKAGE@-$2.tar.gz#, \
    filenamemangle=s#.*/@ANY_VERSION@#@PACKAGE@-$1.tar.gz#" \
https://github.com/BLumia/pineapple-pictures/tags .*/releases/tag/@ANY_VERSION@

## pineapple-pictures 1.1.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -4,13 +4,12 @@
 
 cmake_minimum_required(VERSION 3.16)
 
-project(pineapple-pictures VERSION 1.0.0) # don't forget to update NEWS file and AppStream metadata.
+project(pineapple-pictures VERSION 1.1.0) # don't forget to update NEWS file and AppStream metadata.
 
 include(GNUInstallDirs)
 include(FeatureSummary)
 
 option (EXIV2_METADATA_SUPPORT "Better image metadata support via libexiv2" ON)
-option (PREFER_QT_5 "Prefer to use Qt 5" OFF)
 option (TRANSLATION_RESOURCE_EMBEDDING "Embedding .qm translation files inside resource" OFF)
 
 set (CMAKE_CXX_STANDARD 17)
@@ -18,26 +17,14 @@
 set (CMAKE_AUTOMOC ON)
 set (CMAKE_AUTORCC ON)
 
-if (PREFER_QT_5)
-    find_package(QT NAMES Qt5 REQUIRED COMPONENTS Core)
-else ()
-    find_package(QT NAMES Qt6 REQUIRED COMPONENTS Core)
-endif ()
-
-if (${QT_VERSION_MAJOR} EQUAL "5")
-    set (QT_MINIMUM_VERSION "5.15.2")
-else ()
-    set (QT_MINIMUM_VERSION "6.4")
-endif ()
+find_package(QT NAMES Qt6 REQUIRED COMPONENTS Core)
+
+set (QT_MINIMUM_VERSION "6.4")
 
 find_package(Qt${QT_VERSION_MAJOR} ${QT_MINIMUM_VERSION} REQUIRED
-    COMPONENTS Widgets Svg LinguistTools
+    COMPONENTS Widgets Svg SvgWidgets LinguistTools
     OPTIONAL_COMPONENTS DBus
 )
-
-if (${QT_VERSION_MAJOR} EQUAL "6")
-    find_package(Qt${QT_DEFAULT_MAJOR_VERSION} ${QT_MINIMUM_VERSION} CONFIG REQUIRED SvgWidgets)
-endif ()
 
 if (EXIV2_METADATA_SUPPORT)
     find_package(exiv2)
@@ -117,32 +104,25 @@
     ${PPIC_RC_FILES}
 )
 
-if (${QT_VERSION_MAJOR} EQUAL "6")
-    set(ADD_TRANSLATIONS_ADDITIONAL_ARGS)
-
-    if (Qt6_VERSION VERSION_GREATER_EQUAL "6.9.0")
-        set(ADD_TRANSLATIONS_ADDITIONAL_ARGS MERGE_QT_TRANSLATIONS)
-    endif()
-
-    if (TRANSLATION_RESOURCE_EMBEDDING)
-        qt_add_translations(${EXE_NAME} ${ADD_TRANSLATIONS_ADDITIONAL_ARGS} TS_FILES ${PPIC_TS_FILES})
-    else()
-        qt_add_translations(${EXE_NAME} ${ADD_TRANSLATIONS_ADDITIONAL_ARGS} TS_FILES ${PPIC_TS_FILES} QM_FILES_OUTPUT_VARIABLE PPIC_QM_FILES)
-    endif()
+set(ADD_TRANSLATIONS_ADDITIONAL_ARGS)
+
+if (Qt6_VERSION VERSION_GREATER_EQUAL "6.9.0")
+    set(ADD_TRANSLATIONS_ADDITIONAL_ARGS MERGE_QT_TRANSLATIONS)
+endif()
+
+if (TRANSLATION_RESOURCE_EMBEDDING)
+    qt_add_translations(${EXE_NAME} ${ADD_TRANSLATIONS_ADDITIONAL_ARGS} TS_FILES ${PPIC_TS_FILES})
 else()
-    qt_create_translation(PPIC_QM_FILES ${PPIC_CPP_FILES_FOR_I18N} ${PPIC_TS_FILES})
+    qt_add_translations(${EXE_NAME} ${ADD_TRANSLATIONS_ADDITIONAL_ARGS} TS_FILES ${PPIC_TS_FILES} QM_FILES_OUTPUT_VARIABLE PPIC_QM_FILES)
 endif()
 
 target_sources(${EXE_NAME} PRIVATE ${PPIC_QM_FILES})
 
-target_link_libraries (${EXE_NAME} Qt${QT_VERSION_MAJOR}::Widgets Qt${QT_VERSION_MAJOR}::Svg)
-if (${QT_VERSION_MAJOR} EQUAL "6")
-    target_link_libraries (${EXE_NAME} Qt::SvgWidgets)
-endif ()
+target_link_libraries (${EXE_NAME} Qt${QT_VERSION_MAJOR}::Widgets Qt${QT_VERSION_MAJOR}::Svg Qt${QT_VERSION_MAJOR}::SvgWidgets)
 
 if (exiv2_FOUND)
     if(NOT TARGET Exiv2::exiv2lib AND TARGET exiv2lib)
-        # for exiv2 0.27.x
+        # for exiv2 0.27.x and (macOS?) conan build
         add_library(Exiv2::exiv2lib ALIAS exiv2lib)
     endif()
     target_link_libraries (${EXE_NAME}
@@ -153,7 +133,7 @@
     )
 endif ()
 
-if (TARGET Qt5::DBus OR TARGET Qt6::DBus)
+if (TARGET Qt6::DBus)
     target_link_libraries (${EXE_NAME}
         Qt${QT_VERSION_MAJOR}::DBus
     )

=== debian/changelog ===
pineapple-pictures (1.1.0-1deepin1) unstable; urgency=medium

  * New upstream release.

 -- Gary Wang <opensource@blumia.net>  Fri, 11 Jul 2025 19:30:00 +0800

## pineapple-pictures 1.1.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -4,7 +4,7 @@
 
 cmake_minimum_required(VERSION 3.16)
 
-project(pineapple-pictures VERSION 1.1.0) # don't forget to update NEWS file and AppStream metadata.
+project(pineapple-pictures VERSION 1.1.1) # don't forget to update NEWS file and AppStream metadata.
 
 include(GNUInstallDirs)
 include(FeatureSummary)

=== debian/changelog ===
pineapple-pictures (1.1.1-1) unstable; urgency=medium

  * New upstream version 1.1.1

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Fri, 29 Aug 2025 23:17:57 +0100

## pineapple-pictures 1.3.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -4,7 +4,7 @@
 
 cmake_minimum_required(VERSION 3.16)
 
-project(pineapple-pictures VERSION 1.1.1) # don't forget to update NEWS file and AppStream metadata.
+project(pineapple-pictures VERSION 1.3.0) # don't forget to update NEWS file and AppStream metadata.
 
 include(GNUInstallDirs)
 include(FeatureSummary)
@@ -94,7 +94,8 @@
 set (PPIC_CPP_FILES_FOR_I18N ${PPIC_CPP_FILES})
 
 if (WIN32)
-    list(APPEND PPIC_RC_FILES assets/pineapple-pictures.rc)
+    configure_file(assets/pineapple-pictures.rc.in pineapple-pictures.rc @ONLY)
+    list(APPEND PPIC_RC_FILES ${CMAKE_CURRENT_BINARY_DIR}/pineapple-pictures.rc)
 endif ()
 
 add_executable (${EXE_NAME}
@@ -269,6 +270,25 @@
     )
 endif()
 
+if (WIN32)
+    install(
+        FILES dist/passoc/ppic.pacfg
+        DESTINATION ${CMAKE_INSTALL_BINDIR}
+        RENAME default-assoc.pacfg
+    )
+
+    install(
+        FILES
+            dist/passoc/generic.ico
+            dist/passoc/jpeg.ico
+            dist/passoc/gif.ico
+            dist/passoc/svg.ico
+            dist/passoc/png.ico
+            dist/passoc/psd.ico
+        DESTINATION "${CMAKE_INSTALL_BINDIR}/icons"
+    )
+endif()
+
 feature_summary(WHAT ALL INCLUDE_QUIET_PACKAGES FATAL_ON_MISSING_REQUIRED_PACKAGES)
 
 # CPACK: General Settings
@@ -284,7 +304,7 @@
 elseif (UNIX)
     set (CPACK_SYSTEM_NAME "${CMAKE_SYSTEM_NAME}-${CMAKE_SYSTEM_PROCESSOR}")
     set (CPACK_DEBIAN_PACKAGE_SHLIBDEPS ON)
-    set (CPACK_DEBIAN_PACKAGE_RECOMMENDS "kimageformat-plugins")
+    set (CPACK_DEBIAN_PACKAGE_RECOMMENDS "kimageformat6-plugins")
 endif()
 
 include(CPack)

=== debian/changelog ===
pineapple-pictures (1.3.0-1) unstable; urgency=medium

  [ Gary Wang ]
  * Correct app description

  [ Sudip Mukherjee ]
  * New upstream version 1.3.0
  * Update Standards-Version to 4.7.3

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Sun, 01 Feb 2026 18:28:40 +0000

=== debian/control ===
Source: pineapple-pictures
Section: graphics
Priority: optional
Maintainer: Sudip Mukherjee <sudipm.mukherjee@gmail.com>
Build-Depends: debhelper-compat (= 13), cmake, qt6-base-dev,
 qt6-svg-dev, qt6-tools-dev, libexiv2-dev
Standards-Version: 4.7.3
Homepage: https://github.com/BLumia/pineapple-pictures
Vcs-Browser: https://salsa.debian.org/sudip/pineapple-pictures
Vcs-Git: https://salsa.debian.org/sudip/pineapple-pictures.git

Package: pineapple-pictures
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Lightweight Qt-based image viewer
 An uncluttered and fast image viewer which is very simple and easy to
 use. There is also an option to make the window stay on top so users
 can also pin the window with their image as a reference image window
 and work with other software they want. This software will always keep
 the image file as-is, will never accidentally modify the original
 image file when you just simply rotated the image and etc.
 .
 Key features:
   - Minimized UI
   - Fast
   - Easy to use
   - High quality scaling
   - Never modify the original image file
   - Stay-on-top option available for pinning reference image
     and work with other applications
